<template>
    <div>
        <div class="form-group form-inline edit__set_block white-space">
            <h4 class="mb-4">
                Bar Settings
            </h4>
            <div class="full-width">
                <div class="row mb-4">
                    <div class="col-12 mb-4 col-mb-6">
                        <div class="title-text">
                            Position
                        </div>
                        <div class="form-inline">
                            <b-select
                                v-model="popup.bar_position"
                                class="my-select-menu full-width"
                            >
                                <option value="0">
                                    Top
                                </option>
                                <option value="1">
                                    Bottom
                                </option>
                                <option value="2">
                                    Disable
                                </option>
                            </b-select>
                        </div>
                    </div>
                    <div class="col-12 mb-4 col-mb-6">
                        <div class="full-width">
                            <div
                                class="title-text"
                                for="btn-color"
                            >
                                Close Button Color
                            </div>
                            <div class="jscolor-group">
                                <b-form-input
                                    id="btn-color"
                                    v-model="popup.colors.bar_btn_color"
                                    data-vv-as="Header Color"
                                    type="text"
                                    class="my-input full-width"
                                />
                                <button
                                    id="bar-btn"
                                    :style="{background: popup.colors.bar_btn_color}"
                                    class="btn btn-color"
                                    type="button"
                                    @click="showBtnPicker"
                                />

                                <div
                                    v-show="btnColor.active"
                                    class="chrome-picker"
                                >
                                    <chrome-picker v-model="btn" />
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="full-width mb-4">
                <h4>Bar Text</h4>
            </div>
            <div class="full-width">
                <div class="row mb-4">
                    <div class="col-12 mb-4 col-mb-6">
                        <b-select
                            v-model="tag"
                            class="my-select-menu full-width"
                            @change="changeTag"
                        >
                            <option value="tags">
                                tags
                            </option>
                            <option value="{domain}">
                                {domain}
                            </option>
                            <option value="{siteName}">
                                {siteName}
                            </option>
                            <option value="{storeEmail}">
                                {storeEmail}
                            </option>
                            <option value="{timeLeft}">
                                {timeLeft}
                            </option>
                            <option
                                v-if="popup.growth_offers[0].automatic_discount_enabled==1"
                                value="{discountValue}"
                            >
                                {discountValue}
                            </option>
                            <option value="{discountCode}">
                                {discountCode}
                            </option>
                        </b-select>
                    </div>
                </div>
            </div>
            <div class="full-width mb-4">
                <validation-element
                    type="textarea"
                    v-model="popup.bar_text"
                    customInputClass="my-text-area"
                    name="Bar Text"
                    rows="5"
                    @focus="focus"
                />
            </div>
            <div class="row mb-4">
                <div class="col-12 mb-4 col-mb-6">
                    <div class="full-width">
                        <div class="title-text">
                            Bar Text Color
                        </div>
                        <div class="jscolor-group">
                            <b-form-input
                                id="settings-title-color"
                                v-model="popup.colors.bar_text"
                                data-vv-as="Header Color"
                                type="text"
                                class="my-input full-width"
                            />
                            <button
                                :style="{background: popup.colors.bar_text}"
                                class="btn btn-color"
                                type="button"
                                @click="showPicker"
                            />

                            <div
                                v-show="textColor.active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="text" />
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-12 mb-4 col-mb-6">
                    <div class="full-width">
                        <div class="title-text">
                            Bar Background Color
                        </div>
                        <div class="jscolor-group">
                            <b-form-input
                                id="settings-bar-color"
                                v-model="popup.colors.bar_color"
                                data-vv-as="Header Color"
                                type="text"
                                class="form-control full-width"
                            />
                            <button
                                :style="{background: popup.colors.bar_color}"
                                class="btn btn-color bar-color"
                                type="button"
                                @click="showBarPicker"
                            />

                            <div
                                v-show="barColor.active"
                                class="chrome-picker"
                            >
                                <chrome-picker v-model="bar" />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="full-width pointer">
                Allow Closing
                <div class="full-width right">
                    <toggle-button
                        v-model="popup.bar_allow_closing"
                        :sync="true"
                        :labels="true"
                        color="#2d77f5"
                        :height="24" 
                    />
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import {Chrome} from 'vue-color';
import ValidationElement from '../elements/ValidationElement.vue';

export default {
    components: {
        'chrome-picker': Chrome,

        ValidationElement
    },
    props: {
        popup: Object
    },
    data() {
        return {
            textColor: {active: false},
            text: '',
            barColor: {active: false},
            bar: '',
            tag:'tags',
            focused:'',
            btnColor: {active: false},
            btn: '',
        }
    },
    watch: {
        text: {
            deep: true,
            handler() {
                this.popup.colors.bar_text = this.text.hex;
            }
        },
        bar: {
            deep: true,
            handler() {
                this.popup.colors.bar_color = this.bar.hex;
            }
        },
        btn: {
            deep: true,
            handler() {
                this.popup.colors.bar_btn_color = this.btn.hex;
            }
        }
    },
    methods: {
        focus(e) {
            this.focused = e.target;
        },
        changeTag() {
            if(this.focused) {
                this.popup.bar_text = this.popup.bar_text.slice(0, this.focused.selectionStart)
                  + `${this.tag}` + this.popup.bar_text.slice(this.focused.selectionStart);
                this.focused.focus();
                this.focused.parentElement.classList.remove('has-error')
                this.tag = 'tags'
            }else{
                this.tag = 'tags'
            }
        },
        showPicker() {
            this.hidePicker();
            this.hideBarPicker();
            this.hideBtnPicker();
            document.addEventListener('click', this.documentClick);

            this.textColor.active = true;
        },
        hidePicker() {
            document.removeEventListener('click', this.documentClick);

            this.textColor.active = false;
        },
        showBarPicker() {
            this.hideBarPicker();
            this.hidePicker();
            this.hideBtnPicker();
            document.addEventListener('click', this.documentBarClick);

            this.barColor.active = true;
        },
        showBtnPicker(){
            this.hideBarPicker();
            this.hidePicker();
            this.hideBtnPicker();
            document.addEventListener('click', this.documentBtnClick);

            this.btnColor.active = true;
        },
        hideBarPicker() {
            document.removeEventListener('click', this.documentBarClick);

            this.barColor.active = false;
        },
        hideBtnPicker() {
            document.removeEventListener('click', this.documentBtnClick);

            this.btnColor.active = false;
        },
        documentClick(e) {
            if (e.target.className.indexOf('btn-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hidePicker()
            }
        },
        documentBarClick(e) {
            if (e.target.className.indexOf('bar-color') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideBarPicker()
            }
        },
        documentBtnClick(e) {
            if (e.target.id.indexOf('bar-btn') === -1 && e.target.className.substr(0, 2) !== 'vc') {
                this.hideBtnPicker()
            }
        },
    }
}
</script>

<style scoped>

.my-select-menu {
    height: 40px;
}

.right {
    float: right;
}

.email-container label{
    font-weight: 400!important;
}
.select-tags{
    margin: 0 0 15px 0;
}
.chrome-picker {
    z-index: 999;
}
.pointer {
    cursor: pointer;
    height: 25px;
    display: flex;
    justify-content: space-between;
    align-items: center;
}
.jscolor-group{
    max-width: 100%;
}
</style>
